#include "..\mqbench.h"

int g_MultiThreadSupport = FALSE;

void GetTime_OS(TIMESTRUCT_OS* pTS) {
  ftime(pTS);
}

double GetElapsedTime_OS(TIMESTRUCT_OS* pStartTime, TIMESTRUCT_OS* pEndTime) {
  double start = (pStartTime->time + (float)pStartTime->millitm / 1000);
  double end = (pEndTime->time + (float)pEndTime->millitm / 1000);
  
  return end - start;
}

void CreateEvents_OS(void)
{
}

void CloseEvents_OS(void) {
}

VOID
WINAPI
Sleep(
    DWORD dwMilliseconds
    );

void Sleep_OS(ULONG ulMilliSeconds) {
  Sleep(ulMilliSeconds);
}

void SetEvent_OS(EVENTOBJ_OS hEvent) {
}

void ResetEvent_OS(EVENTOBJ_OS hEvent) {
}

void WaitForEvent_OS(EVENTOBJ_OS hEvent) {
}

LONG InterlockedDecrement_OS(LONG* pDecVar) {
  (*pDecVar)--;
  return *pDecVar;
}

LONG InterlockedExchange_OS(LONG* pExchgVar, LONG NewVal) {
  LONG prevVal = *pExchgVar;
  *pExchgVar = NewVal;

  return prevVal;
}

void StartThreads_OS(void) {
  TestThread(NULL);
}
